<?php

$content = "<h1>Place an Order</h1>";

// define a variable with path to the script which will process form
// ->	$_SERVER["PHP_SELF"] is a path to the current script (index.php)
$action = $_SERVER["PHP_SELF"]."?page=place-order";

// turn autocommit off
mysqli_autocommit($link, FALSE);

// start a transaction
mysqli_query($link, 'START TRANSACTION');

// fetch the albums so that we have access to their names and upc's
// lock in shared mode so affected data cannot be altered by other 
// sessions BEFORE the transaction is committed or rolled back.
// only list albums that are in stock.
$sql = "SELECT title, upc
        FROM Album
		INNER JOIN Inventory
		ON Album.upc=Inventory.album_upc
		WHERE Inventory.stock>0
	    ORDER BY title LOCK IN SHARE MODE";

$result = mysqli_query($link, $sql);

// check query returned a result
if ($result === false) {
    echo mysqli_error($link);
} else {
    $options = "";
    // create an option for each album
    while ($row = mysqli_fetch_assoc($result)) {
        $options .= "<option value='".$row['upc']."'>";
        $options .= $row['title'];
        $options .= "</option>";
    }
}

// define the form HTML (would ideally be in a template)
// note that the customer_id is a hidden field
// we'll assume they're a logged in customer and their
// id is saved in the $_SESSION variable (more on that in term 2)
$form_html = "<form action='".$action."' method='POST'>
				<input type='hidden' name='cust_id' value='1'>
                <fieldset>
                    <label for='upc'>Album:</label>
                    <select name='upc' required>
						<option value='' disabled selected>Select an album</option>

                        ".$options."
                    </select>
                </fieldset>
                <fieldset>
                    <label for='qty'>Quantity required:</label>
					<input type='number' name='qty' min='1' max='25'>
                </fieldset>
                <fieldset>
                    <label for='delivery'>Select delivery method:</label>
                    <select name='delivery' required>
						<option value='second class' selected>second class</option>
						<option value='first class'>first class</option>
						<option value='next working day'>next working day</option>
                    </select>
                </fieldset>
                <button type='submit'>Place order</button>
              </form>";

// append form HTML to content string
$content .= $form_html;

// ------- START form processing code... -------

// define variables and set to empty values
$upc = $stock = $qty = $cust_id = $delivery = "";

// check if there was a POST request
if ($_SERVER["REQUEST_METHOD"] == "POST") {
	// validate the form data
	$qty = mysqli_real_escape_string($link, clean_input($_POST["qty"]));
	$upc =  mysqli_real_escape_string($link, clean_input($_POST["upc"]));
	$cust_id =  mysqli_real_escape_string($link, clean_input($_POST["cust_id"]));
	$delivery =  mysqli_real_escape_string($link, clean_input($_POST["delivery"]));

	// define query to get stock info for album that has been ordered
	// lock the data FOR UPDATE so that it cannot be read by other 
	// sessions BEFORE the transaction is committed or rolled back
	$sql1 = "SELECT stock FROM Inventory WHERE album_upc=".$upc." FOR UPDATE";

	// run first query
	$result = mysqli_query($link, $sql1);

	// check first query returned a result
	if ($result === false) {
		exit(mysqli_error($link)); // exit script with message
	}

	// get the stock value from the first result-set
	$row = mysqli_fetch_row($result);
	$stock = $row[0];

	// check if there are enough albums in stock, and calculate new stock
	if ($qty <= $stock) {
		$new_stock_val = $stock - $qty;
	} else {
		exit("Sorry, we have insufficient stock."); // exit script 
	}

	// define the insertion query needed to add row to Transaction (order) table
	$sql2 = sprintf("INSERT INTO Transaction (customer_id, delivery)
		VALUES (%d, '%s')", $cust_id, $delivery);

	// run second query
	$result2 = mysqli_query($link, $sql2);
	
	// get id of last row inserted (the transaction id)
	$trans_id = mysqli_insert_id($link);

	// define insertion query needed to add row to LineItem table
	$sql3 = sprintf("INSERT INTO LineItem (trans_id, album_upc, quantity)
		VALUES (%d, '%s', %d)", $trans_id, $upc, $qty);

	// run the third query
	$result3 = mysqli_query($link, $sql3);

	// define the update query needed to update the Inventory table
	$sql4 = sprintf("UPDATE Inventory SET stock=%d 
		WHERE album_upc='%s'", $new_stock_val, $upc);

	// run the final query
	$result4 = mysqli_query($link, $sql4);

	// check if queries 2-4 all went ok...
	if ($result2 === false || $result3 === false || $result4 === false) {
		// one of them returned false, so rollback transaction...
		mysqli_rollback($link);
		echo mysqli_error($link);
	} else {
		// all completed without error, so commit transaction
		mysqli_commit($link);
		$content .= "Order successfully placed.";
	}

}

// ------- END form processing code... -------

?>
