<?php

// define query to fetch game stats using nested queries
// and aggregate function with GROUP BY clause
// order by ranking (success rate)
$sql = "SELECT Player.username AS player,
(SELECT COUNT(*) FROM Game WHERE Game.player_id=Player.id) AS num_plays,
(SELECT COUNT(*) FROM Game WHERE Game.player_id=Player.id AND Game.won=1) AS num_wins
FROM Player
INNER JOIN Game ON Game.player_id=Player.id
GROUP BY username
ORDER BY num_wins/num_plays DESC";

// query the database
$result = mysqli_query($link, $sql);

// update HTML content string with page title
$content .= "<h1>Leaderboard</h1>";

// get number of rows in result-set
$row_cnt = mysqli_num_rows($result);

// check if there are rows to display...
if ($row_cnt == 0) {
	// if not, output a suitable message
	$content .= "<p>There are no games in the database!</p>";
} else {
	// otherwise, update the HTML in $content

	$content .= "<table cellpadding='4' border='1'>
					<thead align='left'>
						<tr>
							<th>Rank</th>
							<th>Player</th>
							<th>Number of plays</th>
							<th>Number of wins</th>
							<th>Success rate (%)</th>
						</tr>
					</thead>
					<tbody>";
    // while there are rows, fetch each row as an associative array
	$i = 1;
    while ($row = mysqli_fetch_assoc($result)) {
		// calculate the success rate as percent
		$success = round($row['num_wins']/$row['num_plays']*100,0);
		// append the content with more HTML containing row data
		$content .= "<tr>
						<td>".$i."</td>
						<td>".$row['player']."</td> 
						<td>".$row['num_wins']."</td> 
						<td>".$row['num_plays']."</td>
						<td>".$success."</td>
					</tr>"; // reference a field value in the array by its key!
    }
    // free result set
    mysqli_free_result($result);

	$content .= "</tbody></table>";
}

?>
